#!/usr/bin/env node
var co = require('co');
var prompt = require('co-prompt');
var program = require('commander');
var EventEmitter = require("events").EventEmitter;
var evnt = new EventEmitter();
var chalk = require('chalk');
var models = require('./sampleobject');

var error = chalk.bold.red;
var print = chalk.bold.blue;
var success = chalk.bold.green;
if (!process.argv[2]) {
	console.log(error("Please enter your connector path"));
}

program
    .arguments('<file>')
    .action(function(file) {
    co(function *() {
        var operation, option, optionType, connectorType, triggerOption, credentialKeyString,credentialKeyList;
        var count = 0;
        var credentialsList = {};
        var node = {};

        do {
            if (count != 0) {
                console.log(error("Please enter valid operation"));
            }
            operation = yield prompt(print('Operation (init/test): '));
            count++;
        } while(operation != "init" && operation != "test");
        count = 0;

        do {
            if (count != 0) {
                console.log(error("Please enter valid credential key list"));
            }
            credentialKeyString = yield prompt(print('Enter credentials key list split by comma: '));
            credentialKeyList = credentialKeyString.split(',');
            count++;
        } while(credentialKeyList.length == 1 && credentialKeyList[0] == "");            
        count = 0;

        for (var i = 0 ; i < credentialKeyList.length; i++) {
            do {
                if (count != 0) {
                    console.log(error("Please enter value for " + credentialKeyList[i]));
                }
                var credentialValue = yield prompt(print('Enter value for ' + credentialKeyList[i] + ' : '));
                credentialsList[credentialKeyList[i].trim()] = credentialValue.trim();
                count++;
            } while(credentialValue.trim() == "");
            count = 0;            
        };

        node.credentials = credentialsList;

        if (operation == "init") {
            do {
                if (count != 0) {
                    console.log(error("Please enter valid connector type"));
                }
                connectorType = yield prompt(print('Connector Type (trigger/action): '));
                count++;
            } while(connectorType != "trigger" && connectorType != "action");
            count = 0;

            option = yield prompt(print('Option : '));
            optionType = yield prompt(print('Option type : '));
            node.option = option;
            node.optionType = optionType;
            var obj = {
                fileName : file,
                type : connectorType
            }
            node.connector = obj;
            node.connection = models.connection;
            if (connectorType == "action") {
                do {
                    if (count != 0) {
                        console.log(error("Please enter valid trigger option"));
                    }
                    triggerOption = yield prompt(print('Enter your trigger option (customer/product/order) : '));
                    count++;
                } while(triggerOption.trim() != "customer" && triggerOption.trim() != "product" && triggerOption.trim() != "order");
                count = 0;

                node.reqData = models[triggerOption.toLowerCase()];
            }
            require(file).init(node);
        } else if (operation.toLowerCase() == "test") {
			require(file).test(node,function(resObj){
				console.log(print("*******************************RESULT*******************************"));
				if (resObj && typeof(resObj) == "object") console.log(print("%j"),resObj);
				else console.log(print(resObj));			
				console.log(print("********************************************************************"));
			});
        }
    });
}).parse(process.argv);

evnt.on("error", function(message, postData, url, node){
    if (!node) {
        console.log(error("'node' not found in your data posted to 'error' event"));
    } else if (!message) {
        console.log(error("'message' not found in your data posted to 'error' event"));
    } else if (!node.hasOwnProperty("connector")) {
        console.log(error("'connector' key not found in node"));
    } else if (!node.connector.hasOwnProperty("type")) {
        console.log(error("'type' Key does not exist in connector"));
    } else if (!node.hasOwnProperty("connection")) {
        console.log(error("'connection' key not found in your data posted to 'error' event"));
    } else if (node.connector.type == "action" && !node.hasOwnProperty("reqData")) {
		console.log(error("'reqData' key not found in your data posted to 'error' event"));
	} else if (node.connector.type == "action" && !node.reqData.hasOwnProperty("_id")) {
		console.log(error("'_id' key not found in your data posted to 'error' event"));
    } else {
		console.log(error("******************************ERROR*********************************"));
		console.log(error("Error : " + message));
		if (postData && typeof(postData) == "object") console.log(error("Detail : %j"),postData);
		else console.log(error("Detail : " + postData));
		console.log(error("URl : " + url));
		console.log(error("********************************************************************"));
    }
});

evnt.on("success", function(node, message) {
    if (!node) {
        console.log(error("'node' not found in your data posted to 'success' event"));
    } else if (!node.hasOwnProperty("connector")) {
        console.log(error("'connector' key not found in node"));
    } else if (!node.connector.hasOwnProperty("type")) {
        console.log(error("'type' key does not exist in connector"));
    } else {
        if (node.connector.type == "trigger") {
            if (!node.hasOwnProperty("resData")) {
                console.log(error("'resData' key not found in your data posted to 'success' event"));
            } else if (!Array.isArray(node.resData)) {
                console.log(error("Value of 'resData' is not an Array"));
            } else {
	        	console.log(success("*****************************SUCCESS********************************"));
				console.log(success("%j"),node.resData);
		        console.log(success("********************************************************************"));
            }
        } else if (node.connector.type == "action") {
            if (!node.hasOwnProperty("reqData")) {
                console.log(error("'reqData' key not found in your data posted to 'success' event"));
            } else if (!node.reqData.hasOwnProperty("_id")) {
                console.log(error("'_id' key not found in your data posted to 'success' event"));
            } else if (!node.hasOwnProperty("connection")) {
                console.log(error("'connection' key not found in your data posted to 'success' event"));
            } else {
	        	console.log(success("*****************************SUCCESS********************************"));
                console.log(success("Success : "+message));
	        	console.log(success("********************************************************************"));
            }
        }
    }
});

module.exports.emit = function (type,node,message,url,data) {
    if (type == "success") evnt.emit("success",node,message);
    else if (type == "error") evnt.emit("error",node,message,url,data);
}
